org.apache.tinkerpop.gremlin.process.traversal.step.map

## Class OrderGlobalStep<S,C extends Comparable>

- java.lang.Object
- - org.apache.tinkerpop.gremlin.process.traversal.step.util.AbstractStep<S,S>
  - - org.apache.tinkerpop.gremlin.process.traversal.step.util.CollectingBarrierStep<S>
    - - org.apache.tinkerpop.gremlin.process.traversal.step.map.OrderGlobalStep<S,C>

- All Implemented Interfaces:
    Serializable, AutoCloseable, Cloneable, Iterator<Traverser.Admin<S>>, Step<S,S>, Barrier<TraverserSet<S>>, ByModulating, ComparatorHolder<S,C>, MemoryComputing<TraverserSet<S>>, Seedable, TraversalParent

      public final class OrderGlobalStep<S,C extends Comparable>
      extends CollectingBarrierStep<S>
      implements ComparatorHolder<S,C>, TraversalParent, ByModulating, Seedable

  Author:
    Marko A. Rodriguez (http://markorodriguez.com)
  See Also:
    Serialized Form

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `OrderGlobalStep.OrderBiOperator<S>`

  - ### Field Summary

    - ### Fields inherited from class org.apache.tinkerpop.gremlin.process.traversal.step.util.CollectingBarrierStep

      `traverserSet`

    - ### Fields inherited from class org.apache.tinkerpop.gremlin.process.traversal.step.util.AbstractStep

      `id, labels, nextEnd, nextStep, previousStep, starts, traversal, traverserStepIdAndLabelsSetByChild`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `OrderGlobalStep(Traversal.Admin traversal)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addComparator(Traversal.Admin<S,C> traversal, Comparator<C> comparator)` Add a `Traversal`-based `Comparator` to the holder.
    `void` | `barrierConsumer(TraverserSet<S> traverserSet)`
    `OrderGlobalStep<S,C>` | `clone()` Cloning is used to duplicate steps for the purpose of traversal optimization and OLTP replication.
    `List<org.javatuples.Pair<Traversal.Admin<S,C>,Comparator<C>>>` | `getComparators()` Get the comparators associated with this holder.
    `long` | `getLimit()`
    `List<Traversal.Admin<S,C>>` | `getLocalChildren()`
    `MemoryComputeKey<TraverserSet<S>>` | `getMemoryComputeKey()` The `MemoryComputeKey` that will be used by this step.
    `Set<TraverserRequirement>` | `getRequirements()` Provide the necessary `TraverserRequirement` that must be met by the traverser in order for the step to function properly.
    `int` | `hashCode()`
    `void` | `modulateBy(Traversal.Admin<?,?> traversal)`
    `void` | `modulateBy(Traversal.Admin<?,?> traversal, Comparator comparator)`
    `void` | `processAllStarts()` Process all left traversers by do not yield the resultant output.
    `void` | `replaceLocalChild(Traversal.Admin<?,?> oldTraversal, Traversal.Admin<?,?> newTraversal)`
    `void` | `resetSeed(long seed)`
    `void` | `setLimit(long limit)`
    `void` | `setTraversal(Traversal.Admin<?,?> parentTraversal)` Set the `Traversal` that this step is contained within.
    `String` | `toString()`

    - ### Methods inherited from class org.apache.tinkerpop.gremlin.process.traversal.step.util.CollectingBarrierStep

      `addBarrier, hasNextBarrier, nextBarrier, processNextStart, reset`

    - ### Methods inherited from class org.apache.tinkerpop.gremlin.process.traversal.step.util.AbstractStep

      `addLabel, addStart, addStarts, equals, getId, getLabels, getNextStep, getPreviousStep, getStarts, getTraversal, hasNext, hasStarts, isTraverserStepIdAndLabelsSetByChild, next, prepareTraversalForNextStep, removeLabel, setId, setNextStep, setPreviousStep`

    - ### Methods inherited from class java.lang.Object

      `finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.step.TraversalParent

      `addGlobalChild, addLocalChild, asStep, close, getGlobalChildren, getSelfAndChildRequirements, integrateChild, removeGlobalChild, removeLocalChild`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.step.ByModulating

      `modulateBy, modulateBy, modulateBy, modulateBy, modulateBy, modulateBy, modulateBy, modulateBy, modulateBy, modulateBy`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.step.Barrier

      `done`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.Step

      `equals`

    - ### Methods inherited from interface java.util.Iterator

      `forEachRemaining, remove`

- - ### Constructor Detail

    - #### OrderGlobalStep

          public OrderGlobalStep(Traversal.Admin traversal)

  - ### Method Detail

    - #### resetSeed

          public void resetSeed(long seed)

      Specified by:
        `resetSeed` in interface `Seedable`

    - #### barrierConsumer

          public void barrierConsumer(TraverserSet<S> traverserSet)

      Specified by:
        `barrierConsumer` in class `CollectingBarrierStep<S>`

    - #### processAllStarts

          public void processAllStarts()

      Description copied from interface: `Barrier`
      Process all left traversers by do not yield the resultant output. This method is useful for steps like `ReducingBarrierStep`, where traversers can be processed "on the fly" and thus, reduce memory consumption.
      Specified by:
        `processAllStarts` in interface `Barrier<TraverserSet<S>>`
      Overrides:
        `processAllStarts` in class `CollectingBarrierStep<S>`

    - #### setLimit

          public void setLimit(long limit)

    - #### getLimit

          public long getLimit()

    - #### addComparator

          public void addComparator(Traversal.Admin<S,C> traversal,
                                    Comparator<C> comparator)

      Description copied from interface: `ComparatorHolder`
      Add a `Traversal`-based `Comparator` to the holder. If no traversal is needed, use `IdentityTraversal`.
      Specified by:
        `addComparator` in interface `ComparatorHolder<S,C extends Comparable>`
      Parameters:
        `traversal` - the traversal to pre-process the object by.
        `comparator` - the comparator to compare the result of the object after traversal processing

    - #### modulateBy

          public void modulateBy(Traversal.Admin<?,?> traversal)

      Specified by:
        `modulateBy` in interface `ByModulating`

    - #### modulateBy

          public void modulateBy(Traversal.Admin<?,?> traversal,
                                 Comparator comparator)

      Specified by:
        `modulateBy` in interface `ByModulating`

    - #### replaceLocalChild

          public void replaceLocalChild(Traversal.Admin<?,?> oldTraversal,
                                        Traversal.Admin<?,?> newTraversal)

      Specified by:
        `replaceLocalChild` in interface `TraversalParent`

    - #### getComparators

          public List<org.javatuples.Pair<Traversal.Admin<S,C>,Comparator<C>>> getComparators()

      Description copied from interface: `ComparatorHolder`
      Get the comparators associated with this holder. The comparators are ordered according to their oder of operation.
      Specified by:
        `getComparators` in interface `ComparatorHolder<S,C extends Comparable>`
      Returns:
        a list of `Traversal`/`Comparator`-pairs

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `CollectingBarrierStep<S>`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `CollectingBarrierStep<S>`

    - #### getRequirements

          public Set<TraverserRequirement> getRequirements()

      Description copied from interface: `Step`
      Provide the necessary `TraverserRequirement` that must be met by the traverser in order for the step to function properly. The provided default implements returns an empty set.
      Specified by:
        `getRequirements` in interface `Step<S,S>`
      Overrides:
        `getRequirements` in class `CollectingBarrierStep<S>`
      Returns:
        the set of requirements

    - #### getLocalChildren

          public List<Traversal.Admin<S,C>> getLocalChildren()

      Specified by:
        `getLocalChildren` in interface `TraversalParent`

    - #### clone

          public OrderGlobalStep<S,C> clone()

      Description copied from interface: `Step`
      Cloning is used to duplicate steps for the purpose of traversal optimization and OLTP replication. When cloning a step, it is important that the steps, the cloned step is equivalent to the state of the step when `Step.reset()` is called. Moreover, the previous and next steps should be set to `EmptyStep`.
      Specified by:
        `clone` in interface `Step<S,S>`
      Overrides:
        `clone` in class `CollectingBarrierStep<S>`
      Returns:
        The cloned step

    - #### setTraversal

          public void setTraversal(Traversal.Admin<?,?> parentTraversal)

      Description copied from interface: `Step`
      Set the `Traversal` that this step is contained within.
      Specified by:
        `setTraversal` in interface `Step<S,S>`
      Overrides:
        `setTraversal` in class `AbstractStep<S,S>`
      Parameters:
        `parentTraversal` - the new traversal for this step

    - #### getMemoryComputeKey

          public MemoryComputeKey<TraverserSet<S>> getMemoryComputeKey()

      Description copied from interface: `MemoryComputing`
      The `MemoryComputeKey` that will be used by this step.
      Specified by:
        `getMemoryComputeKey` in interface `MemoryComputing<TraverserSet<S>>`
      Overrides:
        `getMemoryComputeKey` in class `CollectingBarrierStep<S>`
      Returns:
        the MemoryComputeKey to use

Copyright © 2013–2022 Apache Software Foundation. All rights reserved.